math2d = require("math2d")

script.on_init(function()
	local mgs = game.get_surface(1).map_gen_settings
	mgs.property_expression_names["p1"] = "rnd-100"
	mgs.property_expression_names["p2"] = "rnd-seed"
	mgs.property_expression_names["p3"] = "rnd-seed-literal"
	game.get_surface(1).map_gen_settings = mgs
end)

function get_area_positions(area)
	local arr = {}
	for x=area.left_top.x,area.right_bottom.x,1 do
		for y=area.left_top.y,area.right_bottom.y,1 do
			table.insert(arr, {x, y})
		end
	end
	return arr
end

commands.add_command("test", nil, function(cmd)
	local player = game.get_player(cmd.player_index)
	local pos_arr = get_area_positions(math2d.bounding_box.create_from_centre({math.floor(player.position.x), math.floor(player.position.y)}, 64, 64))
	
	local it = string.gmatch(cmd.parameter or "", "%S+")
	local mode = it()
	local property = it()
	
	if mode == "a" then
		for _,p in ipairs(pos_arr) do
			local calcresult = player.surface.calculate_tile_properties({property}, {p})
			if calcresult[property] then
				rendering.draw_text{text=string.format("%.4f", calcresult[property][1]), color={1, 1, 1}, surface=player.surface, target=p, scale=0.5, time_to_live=600}
			end
		end
	elseif mode == "b" then
		local calcresult = player.surface.calculate_tile_properties({property}, pos_arr)
		if calcresult[property] then
			for i,p in ipairs(pos_arr) do
				rendering.draw_text{text=string.format("%.4f", calcresult[property][i]), color={1, 1, 1}, surface=player.surface, target=p, scale=0.5, time_to_live=600}
			end
		end
	end
end)